Loading...
Searching...
No Matches
wayland::server::zwp_linux_buffer_params_v1_t Class Reference

parameters for creating a dmabuf-based wl_buffer More...

`#include <wayland-server-protocol-unstable.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void()> & | on_destroy ()
| delete this object, used or not
std::function< void(int, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t)> & | on_add ()
| add a dmabuf to the temporary set
std::function< void(int32_t, int32_t, uint32_t, zwp_linux_buffer_params_v1_flags)> & | on_create ()
| create a wl_buffer from the given dmabufs
std::function< void(buffer_t, int32_t, int32_t, uint32_t, zwp_linux_buffer_params_v1_flags)> & | on_create_immed ()
| immediately create a wl_buffer from the given dmabufs
void | created (bool post=true)
| buffer creation succeeded
void | failed (bool post=true)
| buffer creation failed
void | post_already_used (std::string const &msg)
| Post error: the dmabuf_batch object has already been used to create a wl_buffer.
void | post_plane_idx (std::string const &msg)
| Post error: plane index out of bounds.
void | post_plane_set (std::string const &msg)
| Post error: the plane index was already set.
void | post_incomplete (std::string const &msg)
| Post error: missing or too many planes to create a buffer.
void | post_invalid_format (std::string const &msg)
| Post error: format not supported.
void | post_invalid_dimensions (std::string const &msg)
| Post error: invalid width or height.
void | post_out_of_bounds (std::string const &msg)
| Post error: offset + stride * height goes out of dmabuf bounds.
void | post_invalid_wl_buffer (std::string const &msg)
| Post error: invalid wl_buffer resulted from importing dmabufs via the create_immed request on given buffer_params.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | created_since_version = 1
| Minimum protocol version required for the created function.
static constexpr std::uint32_t | failed_since_version = 1
| Minimum protocol version required for the failed function.

## Detailed Description

parameters for creating a dmabuf-based wl_buffer

This temporary object is a collection of dmabufs and other parameters that together form a single logical buffer. The temporary object may eventually create one wl_buffer unless cancelled by destroying it before requesting 'create'.

Single-planar formats only require one dmabuf, however multi-planar formats may require more than one dmabuf. For all formats, an 'add' request must be called once per plane (even if the underlying dmabuf fd is identical).

You must use consecutive plane indices ('plane_idx' argument for 'add') from zero to the number of planes used by the drm_fourcc format code. All planes required by the format must be given exactly once, but can be given in any order. Each plane index can be set only once.

Definition at line 1791 of file wayland-server-protocol-unstable.hpp.

## Member Function Documentation

## created()

void zwp_linux_buffer_params_v1_t::created | ( | bool | post = `true` | ) |

buffer creation succeeded

Returns
  the newly created wl_buffer

This event indicates that the attempted buffer creation was successful. It provides the new wl_buffer referencing the dmabuf(s).

Upon receiving this event, the client should destroy the zlinux_dmabuf_params object.

Definition at line 5029 of file wayland-server-protocol-unstable.cpp.

## failed()

void zwp_linux_buffer_params_v1_t::failed | ( | bool | post = `true` | ) |

buffer creation failed

This event indicates that the attempted buffer creation has failed. It usually means that one of the dmabuf constraints has not been fulfilled.

Upon receiving this event, the client should destroy the zlinux_buffer_params object.

Definition at line 5034 of file wayland-server-protocol-unstable.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## on_add()

std::function< void(int, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t)> & zwp_linux_buffer_params_v1_t::on_add | ( |  | ) |

add a dmabuf to the temporary set

Parameters

  fd | dmabuf fd
  plane_idx | plane index
  offset | offset in bytes
  stride | stride in bytes
  modifier_hi | high 32 bits of layout modifier
  modifier_lo | low 32 bits of layout modifier

This request adds one dmabuf to the set in this zwp_linux_buffer_params_v1.

The 64-bit unsigned value combined from modifier_hi and modifier_lo is the dmabuf layout modifier. DRM AddFB2 ioctl calls this the fb modifier, which is defined in drm_mode.h of Linux UAPI. This is an opaque token. Drivers use this token to express tiling, compression, etc. driver-specific modifications to the base format defined by the DRM fourcc code.

Starting from version 4, the invalid_format protocol error is sent if the format + modifier pair was not advertised as supported.

This request raises the PLANE_IDX error if plane_idx is too large. The error PLANE_SET is raised if attempting to set a plane that was already set.

Definition at line 5011 of file wayland-server-protocol-unstable.cpp.

## on_create()

std::function< void(int32_t, int32_t, uint32_t, zwp_linux_buffer_params_v1_flags)> & zwp_linux_buffer_params_v1_t::on_create | ( |  | ) |

create a wl_buffer from the given dmabufs

Parameters

  width | base plane width in pixels
  height | base plane height in pixels
  format | DRM_FORMAT code
  flags | see enum flags

This asks for creation of a wl_buffer from the added dmabuf buffers. The wl_buffer is not created immediately but returned via the 'created' event if the dmabuf sharing succeeds. The sharing may fail at runtime for reasons a client cannot predict, in which case the 'failed' event is triggered.

The 'format' argument is a DRM_FORMAT code, as defined by the libdrm's drm_fourcc.h. The Linux kernel's DRM sub-system is the authoritative source on how the format codes should work.

The 'flags' is a bitfield of the flags defined in enum "flags". 'y_invert' means the that the image needs to be y-flipped.

Flag 'interlaced' means that the frame in the buffer is not progressive as usual, but interlaced. An interlaced buffer as supported here must always contain both top and bottom fields. The top field always begins on the first pixel row. The temporal ordering between the two fields is top field first, unless 'bottom_first' is specified. It is undefined whether 'bottom_first' is ignored if 'interlaced' is not set.

This protocol does not convey any information about field rate, duration, or timing, other than the relative ordering between the two fields in one buffer. A compositor may have to estimate the intended field rate from the incoming buffer rate. It is undefined whether the time of receiving wl_surface.commit with a new buffer attached, applying the wl_surface state, wl_surface.frame callback trigger, presentation, or any other point in the compositor cycle is used to measure the frame or field times. There is no support for detecting missed or late frames/fields/buffers either, and there is no support whatsoever for cooperating with interlaced compositor output.

The composited image quality resulting from the use of interlaced buffers is explicitly undefined. A compositor may use elaborate hardware features or software to deinterlace and create progressive output frames from a sequence of interlaced input buffers, or it may produce substandard image quality. However, compositors that cannot guarantee reasonable image quality in all cases are recommended to just reject all interlaced buffers.

Any argument errors, including non-positive width or height, mismatch between the number of planes and the format, bad format, bad offset or stride, may be indicated by fatal protocol errors: INCOMPLETE, INVALID_FORMAT, INVALID_DIMENSIONS, OUT_OF_BOUNDS.

Dmabuf import errors in the server that are not obvious client bugs are returned via the 'failed' event as non-fatal. This allows attempting dmabuf sharing and falling back in the client if it fails.

This request can be sent only once in the object's lifetime, after which the only legal request is destroy. This object should be destroyed after issuing a 'create' request. Attempting to use this object after issuing 'create' raises ALREADY_USED protocol error.

It is not mandatory to issue 'create'. If a client wants to cancel the buffer creation, it can just destroy this object.

Definition at line 5017 of file wayland-server-protocol-unstable.cpp.

## on_create_immed()

std::function< void(buffer_t, int32_t, int32_t, uint32_t, zwp_linux_buffer_params_v1_flags)> & zwp_linux_buffer_params_v1_t::on_create_immed | ( |  | ) |

immediately create a wl_buffer from the given dmabufs

Parameters

  buffer_id | id for the newly created wl_buffer
  width | base plane width in pixels
  height | base plane height in pixels
  format | DRM_FORMAT code
  flags | see enum flags

This asks for immediate creation of a wl_buffer by importing the added dmabufs.

In case of import success, no event is sent from the server, and the wl_buffer is ready to be used by the client.

Upon import failure, either of the following may happen, as seen fit by the implementation:

- the client is terminated with one of the following fatal protocol errors:
  - INCOMPLETE, INVALID_FORMAT, INVALID_DIMENSIONS, OUT_OF_BOUNDS, in case of argument errors such as mismatch between the number of planes and the format, bad format, non-positive width or height, or bad offset or stride.
  - INVALID_WL_BUFFER, in case the cause for failure is unknown or plaform specific.
- the server creates an invalid wl_buffer, marks it as failed and sends a 'failed' event to the client. The result of using this invalid wl_buffer as an argument in any request by the client is defined by the compositor implementation.

This takes the same arguments as a 'create' request, and obeys the same restrictions.

Definition at line 5023 of file wayland-server-protocol-unstable.cpp.

## on_destroy()

std::function< void()> & zwp_linux_buffer_params_v1_t::on_destroy | ( |  | ) |

delete this object, used or not

Cleans up the temporary data sent to the server for dmabuf-based wl_buffer creation.

Definition at line 5005 of file wayland-server-protocol-unstable.cpp.

## post_already_used()

void zwp_linux_buffer_params_v1_t::post_already_used | ( | std::string const & | msg | ) |

Post error: the dmabuf_batch object has already been used to create a wl_buffer.

Definition at line 5039 of file wayland-server-protocol-unstable.cpp.

## post_incomplete()

void zwp_linux_buffer_params_v1_t::post_incomplete | ( | std::string const & | msg | ) |

Post error: missing or too many planes to create a buffer.

Definition at line 5054 of file wayland-server-protocol-unstable.cpp.

## post_invalid_dimensions()

void zwp_linux_buffer_params_v1_t::post_invalid_dimensions | ( | std::string const & | msg | ) |

Post error: invalid width or height.

Definition at line 5064 of file wayland-server-protocol-unstable.cpp.

## post_invalid_format()

void zwp_linux_buffer_params_v1_t::post_invalid_format | ( | std::string const & | msg | ) |

Post error: format not supported.

Definition at line 5059 of file wayland-server-protocol-unstable.cpp.

## post_invalid_wl_buffer()

void zwp_linux_buffer_params_v1_t::post_invalid_wl_buffer | ( | std::string const & | msg | ) |

Post error: invalid wl_buffer resulted from importing dmabufs via the create_immed request on given buffer_params.

Definition at line 5074 of file wayland-server-protocol-unstable.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## post_out_of_bounds()

void zwp_linux_buffer_params_v1_t::post_out_of_bounds | ( | std::string const & | msg | ) |

Post error: offset + stride * height goes out of dmabuf bounds.

Definition at line 5069 of file wayland-server-protocol-unstable.cpp.

## post_plane_idx()

void zwp_linux_buffer_params_v1_t::post_plane_idx | ( | std::string const & | msg | ) |

Post error: plane index out of bounds.

Definition at line 5044 of file wayland-server-protocol-unstable.cpp.

## post_plane_set()

void zwp_linux_buffer_params_v1_t::post_plane_set | ( | std::string const & | msg | ) |

Post error: the plane index was already set.

Definition at line 5049 of file wayland-server-protocol-unstable.cpp.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## Member Data Documentation

## created_since_version

constexpr std::uint32_t wayland::server::zwp_linux_buffer_params_v1_t::created_since_version = 1

static constexpr

Minimum protocol version required for the created function.

Definition at line 1973 of file wayland-server-protocol-unstable.hpp.

## failed_since_version

constexpr std::uint32_t wayland::server::zwp_linux_buffer_params_v1_t::failed_since_version = 1

static constexpr

Minimum protocol version required for the failed function.

Definition at line 1989 of file wayland-server-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp